searchData={"items":[{"type":"module","title":"Ueberauth.Strategy.Patreon","doc":"Provides an Ueberauth strategy for authenticating with Patreon.\n\n#","ref":"Ueberauth.Strategy.Patreon.html"},{"type":"module","title":"Setup - Ueberauth.Strategy.Patreon","doc":"Create an application in Patreon for you to use.\n\nRegister a new application at: [patreon dev portal](https://www.patreon.com/portal/registration/register-clients) and get the `client_id` and `client_secret`.\n\nInclude the provider in your configuration for Ueberauth, provide a lost of scopes you want to request from the user using the `default_scope`.\n\n    config :ueberauth, Ueberauth,\n      providers: [\n        patreon: { Ueberauth.Strategy.Patreon, [default_scope: \"identity[email] identity\"]] }\n      ]\n\nThen include the configuration for twitch.\n\n    config :ueberauth, Ueberauth.Strategy.Patreon.OAuth,\n      client_id: System.get_env(\"PATREON_CLIENT_ID\"),\n      client_secret: System.get_env(\"PATREON_CLIENT_SECRET\")\n\nIf you haven't already, create a pipeline and setup routes for the callback handler to receive the credentials.\n\n    pipeline :browser do\n      plug Ueberauth\n      ...\n  end\n\n    scope \"/auth\", MyApp do\n      pipe_through :browser\n\n      get \"/:provider\", AuthController, :request\n      get \"/:provider/callback\", AuthController, :callback\n    end\n\n\nCreate the controller for the callback where you will handle the `Ueberauth.Auth` struct\n\n    defmodule MyApp.AuthController do\n      use MyApp.Web, :controller\n\n      def callback_phase(%{ assigns: %{ ueberauth_failure: fails } } = conn, _params) do\n        # do things with the failure\n      end\n\n      def callback_phase(%{ assigns: %{ ueberauth_auth: auth } } = conn, params) do\n        # do things with the auth, like create the user or log them in\n      end\n    end","ref":"Ueberauth.Strategy.Patreon.html#module-setup"},{"type":"function","title":"Ueberauth.Strategy.Patreon.credentials/1","doc":"Includes the credentials from the Patreon response.","ref":"Ueberauth.Strategy.Patreon.html#credentials/1"},{"type":"function","title":"Ueberauth.Strategy.Patreon.default_options/0","doc":"","ref":"Ueberauth.Strategy.Patreon.html#default_options/0"},{"type":"function","title":"Ueberauth.Strategy.Patreon.extra/1","doc":"Stores the raw information (including the token) obtained from the Patreon\ncallback.","ref":"Ueberauth.Strategy.Patreon.html#extra/1"},{"type":"function","title":"Ueberauth.Strategy.Patreon.handle_cleanup!/1","doc":"Cleans up the private area of the connection used for passing the raw Notion\nresponse around during the callback.","ref":"Ueberauth.Strategy.Patreon.html#handle_cleanup!/1"},{"type":"function","title":"Ueberauth.Strategy.Patreon.handle_request!/1","doc":"Handles the initial redirect to the patreon authentication page.\n\nTo customize the scope (permissions) that are requested by patreon include\nthem as part of your url:\n\n    \"https://www.patreon.com/oauth2/authorize\"","ref":"Ueberauth.Strategy.Patreon.html#handle_request!/1"},{"type":"function","title":"Ueberauth.Strategy.Patreon.info/1","doc":"Fetches the fields to populate the info section of the `Ueberauth.Auth`\nstruct.","ref":"Ueberauth.Strategy.Patreon.html#info/1"},{"type":"function","title":"Ueberauth.Strategy.Patreon.uid/1","doc":"Fetches the uid field from the Patreon response. This defaults to the option `uid_field` which in-turn defaults to `id`","ref":"Ueberauth.Strategy.Patreon.html#uid/1"},{"type":"module","title":"Ueberauth.Strategy.Patreon.OAuth","doc":"An implementation of OAuth2 for Patreon.\n\nTo add your `:client_id` and `:client_secret` include these values in your\nconfiguration:\n\n    config :ueberauth, Ueberauth.Strategy.Patreon.OAuth,\n      client_id: System.get_env(\"PATREON_CLIENT_ID\"),\n      client_secret: System.get_env(\"PATREON_CLIENT_SECRET\")","ref":"Ueberauth.Strategy.Patreon.OAuth.html"},{"type":"function","title":"Ueberauth.Strategy.Patreon.OAuth.authorize_url/2","doc":"","ref":"Ueberauth.Strategy.Patreon.OAuth.html#authorize_url/2"},{"type":"function","title":"Ueberauth.Strategy.Patreon.OAuth.authorize_url!/2","doc":"Provides the authorize url for the request phase of Ueberauth.\n\nNo need to call this usually.","ref":"Ueberauth.Strategy.Patreon.OAuth.html#authorize_url!/2"},{"type":"function","title":"Ueberauth.Strategy.Patreon.OAuth.client/1","doc":"Construct a client for requests to Patreon.\n\nOptionally include any OAuth2 options here to be merged with the defaults:\n\n    Ueberauth.Strategy.Patreon.OAuth.client(\n      redirect_uri: \"http://localhost:4000/auth/patreon/callback\"\n    )\n\nThis will be setup automatically for you in `Ueberauth.Strategy.Patreon`.\n\nThese options are only useful for usage outside the normal callback phase of\nUeberauth.","ref":"Ueberauth.Strategy.Patreon.OAuth.html#client/1"},{"type":"function","title":"Ueberauth.Strategy.Patreon.OAuth.get/4","doc":"","ref":"Ueberauth.Strategy.Patreon.OAuth.html#get/4"},{"type":"function","title":"Ueberauth.Strategy.Patreon.OAuth.get_token/3","doc":"","ref":"Ueberauth.Strategy.Patreon.OAuth.html#get_token/3"},{"type":"function","title":"Ueberauth.Strategy.Patreon.OAuth.get_token!/2","doc":"","ref":"Ueberauth.Strategy.Patreon.OAuth.html#get_token!/2"},{"type":"extras","title":"Overview","doc":"# Überauth Patreon\n\n[![Hex Version](https://img.shields.io/hexpm/v/ueberauth_patreon.svg)](https://hex.pm/packages/ueberauth_patreon)\n\n> Patreon OAuth2 strategy for Überauth.","ref":"readme.html"},{"type":"extras","title":"Installation - Overview","doc":"1. Setup your application in Patreon Development Dashboard https://www.patreon.com/portal/registration/register-clients\n\n1. Add `:ueberauth_patreon` to your list of dependencies in `mix.exs`:\n\n    ```elixir\n    def deps do\n      [{:ueberauth_patreon, \"~> 1.0\"}]\n    end\n    ```\n\n1. Add Patreon to your Überauth configuration:\n\n    ```elixir\n    config :ueberauth, Ueberauth,\n      providers: [\n        patreon: {Ueberauth.Strategy.Patreon, [default_scope: \"identity[email] identity\"]},\n      ]\n    ```\n\n1.  Update your provider configuration:\n\n    ```elixir\n    config :ueberauth, Ueberauth.Strategy.Patreon.OAuth,\n      client_id: System.get_env(\"PATREON_CLIENT_ID\"),\n      client_secret: System.get_env(\"PATREON_CLIENT_SECRET\"),\n      redirect_uri: System.get_env(\"PATREON_REDIRECT_URI\")\n    ```\n\n1.  Include the Überauth plug in your router pipeline:\n\n    ```elixir\n    defmodule TestPatreonWeb.Router do\n      use TestPatreonWeb, :router\n\n      pipeline :browser do\n        plug Ueberauth\n        ...\n       end\n    end\n    ```\n\n1.  Add the request and callback routes:\n\n    ```elixir\n    scope \"/auth\", TestPatreonWeb do\n      pipe_through :browser\n\n      get \"/:provider\", AuthController, :request\n      get \"/:provider/callback\", AuthController, :callback\n    end\n    ```\n\n1. Create a new controller or use an existing controller that implements callbacks to deal with `Ueberauth.Auth` and `Ueberauth.Failure` responses from Patreon.\n\n    ```elixir\n      defmodule TestPatreonWeb.AuthController do\n        use TestPatreonWeb, :controller\n\n        def callback(%{assigns: %{ueberauth_failure: _fails}} = conn, _params) do\n          conn\n          |> put_flash(:error, \"Failed to authenticate.\")\n          |> redirect(to: \"/\")\n        end\n\n        def callback(%{assigns: %{ueberauth_auth: auth}} = conn, _params) do\n          case UserFromAuth.find_or_create(auth) do\n            {:ok, user} ->\n              conn\n              |> put_flash(:info, \"Successfully authenticated.\")\n              |> put_session(:current_user, user)\n              |> configure_session(renew: true)\n              |> redirect(to: \"/\")\n\n            {:error, reason} ->\n              conn\n              |> put_flash(:error, reason)\n              |> redirect(to: \"/\")\n          end\n        end\n      end\n    ```","ref":"readme.html#installation"},{"type":"extras","title":"Calling - Overview","doc":"Once your setup, you can initiate auth using the following URL, unless you changed the routes from the guide:\n\n    /auth/patreon","ref":"readme.html#calling"},{"type":"extras","title":"Documentation - Overview","doc":"The docs can be found at [ueberauth_patreon][package-docs] on [Hex Docs][hex-docs].\n\n[hex-docs]: https://hexdocs.pm\n[package-docs]: https://hexdocs.pm/ueberauth_patreon","ref":"readme.html#documentation"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/), and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [1.0.1] - 2024-03-23\n\n#","ref":"changelog.html"},{"type":"extras","title":"Added - Changelog","doc":"- Added `scopes` to the callback credentials after authorizing with Patreon\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fix `expired_at` always being nil\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Security - Changelog","doc":"- Several dependency updates\n\n## [1.0.0] - 2022-01-01\n\n#","ref":"changelog.html#security"},{"type":"extras","title":"Added - Changelog","doc":"- Initial release","ref":"changelog.html#added"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}